var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).getBranch("gmarks");

var strbundle;

var isSignedIn;
var bookmarkArray=new BookmarkArray();
var sortby="title";
var showIcon;
var showCount;
var gmarksObserver=null;

function doUnload(){
	if (gmarksObserver!=null) gmarksObserver.unregister();
}

function doLoad(){
	strbundle=document.getElementById("gmarksBundle");
	if (prefs.getBoolPref('.showAddBookmark')==false){
		document.getElementById('addGMark').setAttribute('hidden','true');
	}
	showIcon=prefs.getBoolPref('.showFav');
	showCount=prefs.getBoolPref('.showCount');
	searchBox=document.getElementById('txtSearch');
	
	getBookmarksFeed(GM.onLoad,true);
	//GM.getBookmarksFeed('load');
}

var GM = {
	onRetryLoad : function(){
		var container=document.getElementById("signedOffContainer");
		container.setAttribute("hidden","true");
		document.getElementById("gmarkList").setAttribute('hidden','false');
		
		getBookmarksFeed(GM.onLoad,true);
	},
    onLoad : function() {
		if (isSignedIn){
	    	visibleData=getVisibleData();
	     	treeInit();	
			GM.getImages();
			gmarksObserver=new gmarksObserverControl();
		}
		else{
			dump("not signed in!\n");
			var container=document.getElementById("signedOffContainer");
			container.setAttribute("hidden","false");
			var pass=getPassInfo();
			if (pass){
				document.getElementById("txtEmail").value=pass.user;
				document.getElementById("txtPassword").value=pass.password;
			}
			//<iframe src="https://www.google.com/accounts/ServiceLogin?service=toolbar&rm=hide&nui=1"/>
			document.getElementById("gmarkList").setAttribute('hidden','true');1
		}	
	},
    //Gets the new feed
    refresh : function(event) {
        dump("Refresh!\n");		
        treeView.treeBox.beginUpdateBatch();
		var quick=true;
		if (searchBox.value.length>0) quick=false; //We care about notes now because search looks through the notes.,quick=update notes later
        getBookmarksFeed(GM.onRefresh,quick);
		//GM.getBookmarksFeed('refresh');
		//setTimeout("GM.getBookmarksFeed('refresh');",500);
    },
    //After we've gotten the new feed
    onRefresh: function(){
		if (isSignedIn){
	    	var oldVis=visibleData;
	    	var i,j;
	    	
	    	treeView.rowsOpen=0;
			if (searchBox.value.length==0){
		    	visibleData=getVisibleData();
		    	//Check if we previously had the label, and if it was open or close
		    	for (i=0;i<visibleData.length;i++){
		    		//Look for the old label
		    		for (j=0;j<oldVis.length;j++){
						if (oldVis[j].type==0){
			    			if (oldVis[j].fullTitle==visibleData[i].fullTitle){
			    				if (oldVis[j].open==true){//It should be open
			    					treeView.openContainer(i); //Insert ChildData
			    				}
								//dump(oldVis[j].fullTitle+"|"+visibleData[i].fullTitle+"\n");
			    				break;
			    			}
						}
		    		}	
		    	}
			}		
			else{
				var search=searchBox.value.toLowerCase();
				visibleData=new Array();
				for (var i=0;i<bookmarkArray.length;i++){
					if (bookmarkArray[i].combineAll().toLowerCase().indexOf(search)>-1){
						visibleData.push(new BookmarkData(1,bookmarkArray[i]));
					}
				}
			}
	    	GM.getImages();
	    	treeView.treeBox.endUpdateBatch();
		}
		else{
			dump("not signed in!\n");
			var container=document.getElementById("signedOffContainer");
			container.setAttribute("hidden","false");
			document.getElementById("txtEmail").value=prefs.getCharPref(".email");
			document.getElementById("txtPassword").value=prefs.getCharPref(".pass");
			document.getElementById("gmarkList").setAttribute('hidden','true');
			getBookmarksFeed(GM.onLoad,true);
		}
    	//dump("end refresh\n");
    },
	getImages : function(){
		if (!showIcon) return;
		for (var i=0;i<bookmarkArray.length;i++){
			if (bookmarkArray[i].url.substring(0,4)=="http"){
				var url = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
				url.spec = bookmarkArray[i].url;
				var img = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
				img.spec = url.scheme + "://" + url.hostPort + "/favicon.ico";
			  	//dump(img.spec+'\n');
				// Make a new nsIURIChecker
				var uriChecker = Components.classes["@mozilla.org/network/urichecker;1"].createInstance()
								.QueryInterface(Components.interfaces.nsIURIChecker);
				// uri creation needs to be localized
				uriChecker.init(img);
				uriChecker.asyncCheck(new imageURIChecker(i, img), null);
			}	
		}		
	},
    addGMark : function(title, url,label){
		var theUrl = url ? url : window.content.location.href;
		var docTitle = title ? title : window.content.document.title;
		var labels = label ? [label] : new Array();
		var notes=""//document.getSelection();
		if (prefs.getBoolPref('.ctrlD')==true){
			var arg=new wArg(docTitle,theUrl,labels,notes,1);
			window.openDialog("chrome://browser/content/bookmarks/addBookmark2.xul",strbundle.getString("addBookmarkTitle"),"chrome,centerscreen,modal",arg);
		}
		else
			window.openDialog("chrome://gmarks/content/editBookmark.xul",strbundle.getString("addBookmarkTitle"),"chrome,centerscreen,modal",docTitle, theUrl,labels,notes,bookmarkArray.getLabels());
		//setTimeout("GM.refresh()",500);
    },
    onRemoveBookmark : function(id,ask,refresh) {    	
    	//Delete Confirmation gets annoying, maybe it will be an option later.
		//if(ask && !confirm(strbundle.getString("removeBookmark")+' \"'+ bookmarkArray.getBookmarkById(id).title +"\"?")) return; 	  
        var req = new XMLHttpRequest();
		// Asyncronous connection with the Google Bookmarks server
		req.open("POST", 'http://www.google.com/bookmarks/mark', true); 
		req.send('dlq='+id);
		dump("Sending request to remove bookmark... \n");
		req.onreadystatechange = function(ev) {
            dump("Status: "+req.readyState+"\n");
            if(req.readyState == 4) {
                var status = -1;
                try {status = req.status;}catch(e) {}
                if(status == 200) {
                    dump("Bookmark removed! ("+req.status+")\n")
                    if (refresh) GM.refresh();
                }
                else {
                    alert("An error occurred while removing the bookmark"); 
                }
            }
    	}
   },
   onEditBookmark : function(bm) {
		dump("edit bookmark-"+bm.notes+"\n");
		window.openDialog("chrome://gmarks/content/editBookmark.xul",strbundle.getString("editBookmarkTitle"),"chrome,centerscreen,modal",bm.title, bm.url,bm.labels,bm.notes);
	
        GM.refresh();
    },
    onRenameLabel: function(oldLabel, newLabel, refresh){
    	newLabel=newLabel? newLabel : prompt(strbundle.getString("renameLabel"),oldLabel);
    	if (!newLabel) return;

    	var req = new XMLHttpRequest();
		// Asyncronous connection with the Google Bookmarks server
		req.open("POST", 'http://www.google.com/bookmarks/mark', true); 
		req.send('op=modlabel&labels='+encodeURIComponent(oldLabel+','+newLabel));
		dump("Sending request to rename label... \n");
		req.onreadystatechange = function(ev) {
            dump("Status: "+req.readyState+"\n");
            if(req.readyState == 4) {
                var status = -1;
                try {status = req.status;}catch(e) {}
                if(status == 200) {
                    dump("Label Renamed! ("+req.status+")\n")
                    if (refresh) GM.refresh();
                }
                else {
                    //An error occurred while renaming the label
                }
            }
    	}
    },
    onRemoveLabel: function(label,ask,refresh){
    	if (ask && !confirm(strbundle.getString("removeLabel")+" \""+label+"\"?")) return;
    	var req = new XMLHttpRequest();
		// Asyncronous connection with the Google Bookmarks server
		req.open("POST", 'http://www.google.com/bookmarks/mark', true); 
		req.send('op=modlabel&labels='+encodeURIComponent(label));
		dump("Sending request to remove label... \n");
		req.onreadystatechange = function(ev) {
            dump("Status: "+req.readyState+"\n");
            if(req.readyState == 4) {
                var status = -1;
                try {status = req.status;}catch(e) {}
                if(status == 200) {
                    dump("Label Removed! ("+req.status+")\n")
                    if (refresh) GM.refresh();
                }
                else {
                    //An error occurred while removing the label 
                }
            }
    	}
    },///bookmarks/mark?op=modlabel&labels=Bookmarks
    updateBookmark: function(bm,refresh){
    	var req = new XMLHttpRequest();
    	req.open("POST", 'http://www.google.com/bookmarks/mark', true); 
		req.send('q='+encodeURIComponent(bm.url)+'&title='+encodeURIComponent(bm.title)+'&labels='+encodeURIComponent(bm.labels)+'&annotation='+encodeURIComponent(bm.notes));
	
		if (refresh){
			req.onreadystatechange = function(ev) {
				if(req.readyState == 4) {
					var status = -1;
					try {
						status = req.status }
					catch(e) {}
					if(status == 200){
						GM.refresh();
					}
				}
			}
		}
    },
    addLabelToBookmark: function(bm,label){
		label = label ? label : prompt(strbundle.getString("addLabelToBookmarkPrompt"));
		if (label==null || label.length==0) return;

    	if (bookmarkArray.hasLabel(bm.labels,label)) return ;
    	bm.labels.push(label);//Add label

    	GM.updateBookmark(bm,true);
    },
    removeLabelFromBookmark: function(bm,label){
    	dump("remove "+label+"\n");
    	var newLabels=new Array();
    	
    	for (var i=0;i<bm.labels.length;i++){
    		if (bm.labels[i] != label)
    			newLabels.push(bm.labels[i]);
    	}
    	bm.labels=newLabels;
    	
    	GM.updateBookmark(bm,true);
    },
    onRenameBookmark: function(bm,title){
		title= title ? title: prompt(strbundle.getString("renameBookmark"),bm.title)
    	if (title){
    		bm.title=title;
    		GM.updateBookmark(bm,true);
    	}
    },
    onRemoveLabelAndBookmarks: function(label){
    	var bm=bookmarkArray.getBookmarksByLabel(label);
    	for (var i=0;i<(bm.length-1);i++){
    		GM.onRemoveBookmark(bm[i].id,false,false);
    	}
    	GM.onRemoveBookmark(bm[bm.length-1].id,false,true);
    }
}

function gmarksObserverControl()
{
  this.register();
}
gmarksObserverControl.prototype = {
  	observe: function(subject, topic, data) {
	 	if (topic=="gmarks-refresh"){
			dump("REFRESH!----------------------------")
	 		if (data=="" || data==null)
				GM.refresh();
			else
				setTimeout('GM.refresh();',data);
		}
		/*else if (topic=="gmarks-sendBookmarks"){
			Components.classes["@mozilla.org/observer-service;1"]
	         .getService(Components.interfaces.nsIObserverService)
	         .notifyObservers(null, "gmarks-recieveBookmarks", bookmarkArray);
		}*/
  	},
  	register: function() {
    	var observerService = Components.classes["@mozilla.org/observer-service;1"]
                          .getService(Components.interfaces.nsIObserverService);
    	observerService.addObserver(this, "gmarks-refresh", false);
		//observerService.addObserver(this, "gmarks-sendBookmarks", false);
  	},
  	unregister: function() {
    	var observerService = Components.classes["@mozilla.org/observer-service;1"]
                            .getService(Components.interfaces.nsIObserverService);
    	observerService.removeObserver(this, "gmarks-refresh");
		//observerService.removeObserver(this, "gmarks-sendBookmarks");
  		dump('unregister\n');
  	}
}

function imageURIChecker (index, image)
{
	this.index = index;
	this.image = image;
}

imageURIChecker.prototype =
{
	onStartRequest: function(request, context) {},
	onStopRequest: function(request, context, status)
	{
		var i=this.index; 
		if (!bookmarkArray) return;
		if (status == 0 && bookmarkArray.length>i)
		{
			bookmarkArray[i].image=this.image.spec;
			
			//dump('new img('+i+')='+bookmarkArray[i].image+'\n')
			//Fill visibleData and childData
			for (var v=0;v<visibleData.length;v++)
				if (visibleData[v].type > 0 && visibleData[v].url==bookmarkArray[i].url){
					visibleData[v].image=bookmarkArray[i].image;
					treeView.treeBox.invalidateRow(v);
				}
				else if (visibleData[v].type==0){
					for (var n=0;n<visibleData[v].data.length;n++)
						if (visibleData[v].data[n].url==bookmarkArray[i].url)
							visibleData[v].data[n].image=bookmarkArray[i].image;
				}
		}
	}
}

function wArg(title,url,labels,notes,tab){
	this.name=title ? title : url;
	this.url=url;
	this.labels=labels;
	this.selectedTab=tab;
	this.description=notes;
}