var searchBox;

var visibleData=new Array();//=getVisibleData();
/*All
 * ---------------
 * 0=Cell Text
 * 1=if 0, container, if 1, same level as container, 2=child of a container
 * 
 * Visible Data
 * ------------
 * 2=Opened or Closed(true or false)
 * 3=Label Pointer
 * 
 * Bookmarks(Child Data
 * ------------
 * 2=id
 * 3=url
 * 4=labels
 * 5=notes
 * 
 * New Class
 * ----------------
 * type
 * title
 * [id,url,labels,notes]
 * [toggled State, Pointer]
 */
var treeView = {  
	//My vars
	rowsOpen: 0,
	//end my vars
  treeBox: null,
  selection: null,

  get rowCount()                     { return visibleData.length; },
  setTree: function(treeBox)         { this.treeBox = treeBox; },
  getCellText: function(idx, column) {
  	var title=visibleData[idx].title;
	if (showCount && this.isContainer(idx)){
		title+=' ('+visibleData[idx].data.length+')';
	}
	return title;
  },
  isContainer: function(idx)         {
  	if (idx<visibleData.length)
  		 if (visibleData[idx].type==0) return true;
  	return false;
  },
  isContainerOpen: function(idx)     { if (this.isContainer(idx)) return visibleData[idx].open; else return false;},
  isContainerEmpty: function(idx)    { return false; },
  isSeparator: function(idx)         { return false; },
  isSorted: function()               { return false; },
  isEditable: function(idx, column)  { return true; },

  getParentIndex: function(idx) {
  	if (idx>=visibleData.length) return -1;
    if (this.getLevel(idx)==0) return -1;
	var curLevel=this.getLevel(idx);
    for (var t = idx - 1; t >= 0 ; t--) {
      if (this.isContainer(t) && this.getLevel(t)<curLevel) return t;
    }
    return -1;
  },
  getLevel: function(idx) {
    //if (this.isContainer(idx)) return 0;
	if (visibleData[idx].type==0 || visibleData[idx].type==2) return visibleData[idx].level;
    if (visibleData[idx].type==1) return 0; //Containers and bookmarks with no labels
    return 1;
  },
  hasNextSibling: function(idx, after) {
    var thisLevel = this.getLevel(idx);
    for (var t = idx + 1; t < visibleData.length; t++) {
      var nextLevel = this.getLevel(t)
      if (nextLevel == thisLevel) return true;
      else if (nextLevel < thisLevel) return false;
    }
    return false;
  },
  closeContainer: function(idx){
  	this.rowsOpen--;
  	visibleData[idx].open = false;//Not open

  	var thisLevel = this.getLevel(idx);
  	var deletecount = 0;
  	for (var t = idx + 1; t < visibleData.length; t++) {
    	if (this.getLevel(t) > thisLevel) {
			if (visibleData[t].type==0) visibleData[t].open=false;
			deletecount++;
    	}
		else break;
  	}
  	if (deletecount) {
    	visibleData.splice(idx + 1, deletecount);
  	}
  	return deletecount;
  },
  openContainer: function(idx){
  	visibleData[idx].open = true;
  	if (visibleData[idx].level==0) this.rowsOpen++;

	var toinsert = visibleData[idx].data;
	var lvl=visibleData[idx].level+1;
  	for (var i = 0; i < toinsert.length; i++) {
		if (toinsert[i].type==0)
			visibleData.splice(idx + i + 1, 0, toinsert[i]);
		else
    		visibleData.splice(idx + i + 1, 0,  new BookmarkData(2,toinsert[i],lvl));

  	}
  	return toinsert.length;
  },
  toggleOpenState: function(idx) {
    //if (!item[1]) return;
    if (!this.isContainer(idx)) return;

    if (visibleData[idx].open) {
     	 //We close it
      	var deletecount=this.closeContainer(idx);
      	if (deletecount)
      		this.treeBox.rowCountChanged(idx + 1, -deletecount);
    }
    else {
      	var length=this.openContainer(idx);
      	this.treeBox.rowCountChanged(idx + 1, length);
		var lastRow=this.treeBox.getLastVisibleRow();
		if (idx+1+length>lastRow){
			dump("scroll down!\n");
			this.treeBox.scrollByLines((idx+1+length)-lastRow);
		}
    }
  },
  toggleAll: function(){
  	this.treeBox.beginUpdateBatch();	
  	if (this.rowsOpen==0){
  		//Open all rows
  		for (var i=0;i<visibleData.length;i++){
  			if (this.isContainer(i))
  				i+=this.openContainer(i);
  		}
  	}
  	else{
  		//Close all rows
  		for (var i=0;i<visibleData.length;i++){
  			if (this.isContainerOpen(i))
  				this.closeContainer(i);
  		}
  	}
  	this.treeBox.endUpdateBatch();	
  },
  getImageSrc: function(idx, column) {
  	if (this.isContainer(idx) || !showIcon) return ;
	//dump(visibleData[idx].image+'\n');
	return visibleData[idx].image;
  },
    
  getProgressMode : function(idx,column) {},
  getCellValue: function(idx, column) {},
  cycleHeader: function(col, elem) {},
  selectionChanged: function() {},
  cycleCell: function(idx, column) {},
  performAction: function(action) {},
  performActionOnCell: function(action, index, column) {},
  
  getRowProperties: function(idx, column, prop) {},
  getCellProperties: function(idx, column, prop) {
  	if (showIcon==true){
	  var aserv=Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
	  prop.AppendElement(aserv.getAtom("showIcon"));
  	}
  },
  getColumnProperties: function(column, element, prop) {},
  
  canDrop : function(idx, orient) {
  	//return !orient; 
  	if (idx<visibleData.length){
  		if (this.isContainer(idx)){
  			if (orient==0)
  				return true;
  		}
  		else
  			return true;
  	}
  	return false;
  },
  drop : function(index, orient) {
  	if ( !treeDrag) return;
  	var dragIndex=document.getElementById("gmarkList").currentIndex;
  	dump("drop-"+index+"|"+orient+"|"+dragIndex+"\n"); 
  	var label;
  	if (this.isContainer(index))
  		label=visibleData[index].fullTitle;
  	else if (visibleData[index].type==2){
  		var parent=this.getParentIndex(index);
  		if (parent != -1)
  			label=visibleData[parent].fullTitle;
  	}
  	//Add Label to Bookmark(s)
  	var bm=new Array();
  	if (this.isContainer(dragIndex))
  		bm=visibleData[dragIndex].data;
  	else
		bm.push(visibleData[dragIndex]);
  		//bm.push(this.getBookmark(dragIndex));
  	if (label==null || label=="") return;

	for (var i=0;i<bm.length;i++){
		GM.addLabelToBookmark(bm[i],label);
	}

		
  	window.dump("dragged onto label: "+label+"\n");
  },
  //Custom stuff
  getURL: function(idx){return visibleData[idx].url;},
  getBookmark: function(idx){
  	return visibleData[idx];
	//return new bookmark(visibleData[idx][2],visibleData[idx][3],visibleData[idx][0],visibleData[idx][4],visibleData[idx][5]);
  }
};

function treeInit() {
	window.dump("initiated\n");
	var tree = document.getElementById("gmarkList");
	tree.view = treeView;
	tree.selType="single";
}

//chrome://browser/content/utilityOverlay.js
function mouseClick(event){
	var tree=document.getElementById("gmarkList");
	var row = {}, col = {}, obj = {};
	tree.treeBoxObject.getCellAt(event.clientX, event.clientY, row, col, obj);
	var sel=row.value;
	if (obj.value){
  		if (!tree.view.isContainer(sel)){
  			if (event.button<2){
				//Open
				//dump("isContainer: "+treeView.isContainer(sel)+"\n");
				openUILink(treeView.getURL(sel),event,false,true);
			}
			else{//Right Click Bookmark
				tree.setAttribute("context","gm-bookmarkPopup");
				var popup=document.getElementById("remLbl");
				if (visibleData[sel].type==2){
					window.dump("disabled=false\n");
					popup.setAttribute("disabled","false");}
				else{
					window.dump("disabled=true\n");
					popup.setAttribute("disabled","true");}
			}
		}
		else{
			if (event.button==2)
				tree.setAttribute("context","gm-labelPopup");
			else if (event.button==1)
				openInTabs(event);
		}
        }
        else{
        	//not on the tree
        	dump("not in the window\n");
        	tree.setAttribute("context",null);
        }
}

function openInTabs(event){
	var x,y;
	if (!event){
		var popup=document.getElementById("gm-labelPopup");
		x=popup.boxObject.x;
		y=popup.boxObject.y;
	}
	else{
		x=event.clientX;
		y=event.clientY;
	}		
	
	var tree=document.getElementById("gmarkList");
	var row = {}, col = {}, obj = {};
	tree.treeBoxObject.getCellAt(x, y, row, col, obj);
	var sel=row.value;
	
	var labelArray = new Array();	
	labelArray = visibleData[sel].data;//bookmarkArray.getBookmarksByLabel(label);      
	for (var i = 0; i < labelArray.length; i++)
		openUILinkIn(labelArray[i].url, "tabshifted");
}

function removeLabelFromBookmark(event){
	var index=pops.getBookmarkIndex();
	var parent=treeView.getParentIndex(index);
	
	var label=visibleData[parent].fullTitle
	
	GM.removeLabelFromBookmark(visibleData[index],label);
}

function renameLabel(label, newLabel,refresh){
	if (!label)
		label=visibleData[pops.getLabelIndex()];
	newLabel = newLabel ? newLabel : prompt(strbundle.getString("renameLabel"),label.fullTitle);
	if (!newLabel || newLabel=="") return;
	
	var data=label.data;

	for (var i=0;i<data.length;i++){
		dump(data[i].type+"\n");
		if (data[i].type==0){
			if (i==data.length-1 && refresh==null) refresh=true;
			renameLabel(data[i],newLabel+">"+data[i].title,refresh==true);
		}
		else if (data[i].type==null){
			if (refresh==null) refresh=true;
			GM.onRenameLabel(label.fullTitle,newLabel,refresh==true);
			break;	
		}	
	}
	dump("finished renaming "+label.fullTitle+" to "+newLabel+"\n");
}

function removeLabel(label, refresh){
	if (!label)
		label=visibleData[pops.getLabelIndex()];
	if (!confirm(strbundle.getString("removeLabel")+" \""+label.fullTitle+"\"?")) return;
	
	var data=label.data;

	for (var i=0;i<data.length;i++){
		if (data[i].type==0){
			if (i==data.length-1 && refresh==null) refresh=true;
			renmoveLabel(data[i],refresh==true);
		}
		else if (data[i].type==null){
			if (refresh==null) refresh=true;
			GM.onRemoveLabel(label.fullTitle,false,refresh==true);
			break;	
		}	
	}
}

function removeLabelAndBookmarks(label, refresh){
	if (!label)
		label=visibleData[pops.getLabelIndex()];
	
	var data=label.data;

	for (var i=0;i<data.length;i++){
		if (data[i].type==0){
			if (i==data.length-1 && refresh==null) refresh=true;
			removeLabelAndBookmarks(data[i],refresh==true);
		}
		else if (data[i].type==null){
			
			if (i==data.length-1){
				if (refresh==null) refresh=true;
			}
			else if (refresh==true) refresh=null; 
	    	GM.onRemoveBookmark(data[i].id,false,refresh==true);
		}
	}
}

var pops={
	getIndex: function(x,y){
		var row = {}, col = {}, obj = {};
		document.getElementById("gmarkList").treeBoxObject.getCellAt(x, y, row, col, obj);
		
		return row.value;
	},
	getEventIndex:  function(event){
		return this.getIndex(event.clientX,event.clientY);
	},
	getPopupIndex: function(id){
		var popup=document.getElementById(id);
		var x=popup.boxObject.x;
		var y=popup.boxObject.y;
		
		return this.getIndex(x,y);
	},
	getBookmarkIndex: function(){
		return this.getPopupIndex("gm-bookmarkPopup");
	},
	getLabelIndex: function(){
		return this.getPopupIndex("gm-labelPopup");
	},
	getID: function(){
		return visibleData[this.getBookmarkIndex()].id;
	},
	getURL: function(){
		return visibleData[this.getBookmarkIndex()].url;
	},
	getLabels: function(){//For bookmarks
		return visibleData[this.getBookmarkIndex()].url;
	},
	getNotes: function(){
		return visibleData[this.getIBookmarkndex()].notes;
	},
	getBookmark: function(){
		//(id, url, title, labels, notes, date, image) {
		var vis=visibleData[pops.getBookmarkIndex()];
		var bm=new bookmark(vis.id,vis.url,vis.title,vis.labels,vis.notes);
		
		return bm;
		//return visibleData[pops.getBookmarkIndex()];
	},
	
	//For...lables....(the containers)...
	getLabel: function(){
		return visibleData[this.getLabelIndex()].fullTitle;
	}
}

function doSearch(){
	var search=searchBox.value.toLowerCase();
	dump('do search-'+search+'\n');
	treeView.treeBox.beginUpdateBatch();
	if (search.length==0){
		//Normal view
		
		visibleData=getVisibleData();
		
	}
	else {
		treeView.rowsOpen=0;
		visibleData=new Array();
		for (var i=0;i<bookmarkArray.length;i++){
			if (bookmarkArray[i].combineAll().toLowerCase().indexOf(search)>-1){
				visibleData.push(new BookmarkData(1,bookmarkArray[i]));
			}
		}
	}
	treeView.treeBox.endUpdateBatch();
}
/*
		ondraggesture="gmarksObserver.onTreeDragGesture(event);"
		ondragover="nsDragAndDrop.dragOver(event,gmarksObserver)"
                ondragdrop="nsDragAndDrop.drop(event,gmarksObserver)"
                ondragexit="nsDragAndDrop.dragExit(event,gmarksObserver)"
*/